// This file was generated by gir (https://github.com/gtk-rs/gir)
// from ../gir-files
// DO NOT EDIT

use crate::AuthDomain;
use crate::Message;
use glib::object::Cast;
use glib::object::IsA;
use glib::signal::connect_raw;
use glib::signal::SignalHandlerId;
use glib::translate::*;
use std::boxed::Box as Box_;
use std::fmt;
use std::mem::transmute;

glib::wrapper! {
    #[doc(alias = "SoupAuthDomainDigest")]
    pub struct AuthDomainDigest(Object<ffi::SoupAuthDomainDigest, ffi::SoupAuthDomainDigestClass>) @extends AuthDomain;

    match fn {
        type_ => || ffi::soup_auth_domain_digest_get_type(),
    }
}

impl AuthDomainDigest {
    //#[doc(alias = "soup_auth_domain_digest_new")]
    //pub fn new(optname1: &str, : /*Unknown conversion*//*Unimplemented*/Fundamental: VarArgs) -> AuthDomainDigest {
    //    unsafe { TODO: call ffi:soup_auth_domain_digest_new() }
    //}

    #[doc(alias = "soup_auth_domain_digest_encode_password")]
    pub fn encode_password(username: &str, realm: &str, password: &str) -> Option<glib::GString> {
        crate::assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::soup_auth_domain_digest_encode_password(username.to_glib_none().0, realm.to_glib_none().0, password.to_glib_none().0))
        }
    }
}

pub const NONE_AUTH_DOMAIN_DIGEST: Option<&AuthDomainDigest> = None;

pub trait AuthDomainDigestExt: 'static {
    #[doc(alias = "soup_auth_domain_digest_set_auth_callback")]
    fn set_auth_callback<P: Fn(&AuthDomainDigest, &Message, &str) -> Option<String> + 'static>(&self, callback: P);

    //#[doc(alias = "auth-data")]
    //fn auth_data(&self) -> /*Unimplemented*/Fundamental: Pointer;

    //#[doc(alias = "auth-data")]
    //fn set_auth_data(&self, auth_data: /*Unimplemented*/Fundamental: Pointer);

    #[doc(alias = "auth-data")]
    fn connect_auth_data_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId;
}

impl<O: IsA<AuthDomainDigest>> AuthDomainDigestExt for O {
    fn set_auth_callback<P: Fn(&AuthDomainDigest, &Message, &str) -> Option<String> + 'static>(&self, callback: P) {
        let callback_data: Box_<P> = Box_::new(callback);
        unsafe extern "C" fn callback_func<P: Fn(&AuthDomainDigest, &Message, &str) -> Option<String> + 'static>(domain: *mut ffi::SoupAuthDomainDigest, msg: *mut ffi::SoupMessage, username: *const libc::c_char, user_data: glib::ffi::gpointer) -> *mut libc::c_char {
            let domain = from_glib_borrow(domain);
            let msg = from_glib_borrow(msg);
            let username: Borrowed<glib::GString> = from_glib_borrow(username);
            let callback: &P = &*(user_data as *mut _);
            let res = (*callback)(&domain, &msg, username.as_str());
            res.to_glib_full()
        }
        let callback = Some(callback_func::<P> as _);
        unsafe extern "C" fn dnotify_func<P: Fn(&AuthDomainDigest, &Message, &str) -> Option<String> + 'static>(data: glib::ffi::gpointer) {
            let _callback: Box_<P> = Box_::from_raw(data as *mut _);
        }
        let destroy_call3 = Some(dnotify_func::<P> as _);
        let super_callback0: Box_<P> = callback_data;
        unsafe {
            ffi::soup_auth_domain_digest_set_auth_callback(self.as_ref().to_glib_none().0, callback, Box_::into_raw(super_callback0) as *mut _, destroy_call3);
        }
    }

    //fn auth_data(&self) -> /*Unimplemented*/Fundamental: Pointer {
    //    unsafe {
    //        let mut value = glib::Value::from_type(</*Unknown type*/ as StaticType>::static_type());
    //        glib::gobject_ffi::g_object_get_property(self.to_glib_none().0 as *mut glib::gobject_ffi::GObject, b"auth-data\0".as_ptr() as *const _, value.to_glib_none_mut().0);
    //        value.get().expect("Return Value for property `auth-data` getter")
    //    }
    //}

    //fn set_auth_data(&self, auth_data: /*Unimplemented*/Fundamental: Pointer) {
    //    unsafe {
    //        glib::gobject_ffi::g_object_set_property(self.to_glib_none().0 as *mut glib::gobject_ffi::GObject, b"auth-data\0".as_ptr() as *const _, auth_data.to_value().to_glib_none().0);
    //    }
    //}

    fn connect_auth_data_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_auth_data_trampoline<P: IsA<AuthDomainDigest>, F: Fn(&P) + 'static>(this: *mut ffi::SoupAuthDomainDigest, _param_spec: glib::ffi::gpointer, f: glib::ffi::gpointer) {
            let f: &F = &*(f as *const F);
            f(AuthDomainDigest::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(self.as_ptr() as *mut _, b"notify::auth-data\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(notify_auth_data_trampoline::<Self, F> as *const ())), Box_::into_raw(f))
        }
    }
}

impl fmt::Display for AuthDomainDigest {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("AuthDomainDigest")
    }
}
